/**********************************************************************
 * ֻѧϰʹãδɣκ;
 * ӲƬCH32F103C8T6,Ƶ72MHZ
 * ˵ST7775R 16λڳ
 
 ----------------------------------------------------
 |ǧһʾƼ޹˾                        |
 |˾վ:www.qytft.com                            |
 |Ավhttps://shop580133616.taobao.com        |
 |̻() :+86 0755-27908130                     |
 |ҵѯ:18823372746 (쾭 WXͬ)              |
 |ҵѯ:15989313508 (뾭 WXͬ)              |
 ----------------------------------------------------

 ----------------------------------------------------
 |˾ṩ֧֣κμ⻶ӭʱѧϰ    |
 |֧QQ:3597321058                             |
 |֧:qyxskj@126.com                       |
 |֧:13723763193ܹ WXͬţ               |
 |QQȺ:792027219                            |
 ----------------------------------------------------

 * ˵:
 ========================ԴŽ=======================================================        
 |   LCDģ           Ƭ                                                          |
 |     VCC      --->      3.3V      //Դ                                                 |
 |     GND      --->      GND       //Դ                                               |  
 |====================ƼŽ===================================================|
 |   LCDģ 			     Ƭ                                                          |
 |     CS       --->      PA4       //ҺƬѡźţ͵ƽЧ                     |
 |     RST      --->      PA1       //Һλźţ͵ƽЧ                     |
 |     RS       --->      PA5       //Һ/ݿźţ͵ƽߵƽݣ|
 |     WR       --->      PA10      //Һдź                                     |
 |     RD       --->      PA9       //Һź                                     |
 |     DB0~15   --->      PB0~PB15  //Һ16λź                               |
 |     LED      --->      PA15      //Һźţ粻ƣ3.3V             |
 |=============================================================================|
 |	 LCDģ 			     Ƭ                                                          |
 |     T_IRQ    --->      PA12      //жź                                   |
 |     T_DO     --->      PA2       //SPI߶ź                                  |
 |     T_DIN    --->      PA3       //SPIдź                                  |
 |     T_CS     --->      PA11      //Ƭѡź                                   |
 |     T_CLK    --->      PA8       //SPIʱź                                |
 ===========================================================================================
 
 * :2020/5/13
 * 汾V1.0
 * ȨУؾ
 * Copyright(C) ǧһʾƼ޹˾ 2020-2035
 * All rights reserved
**********************************************************************/		
#include "lcd.h"
#include "stdlib.h"
#include "debug.h" 

	   
//LCDҪ
//ĬΪ
_lcd_dev lcddev;

//ɫ,ɫ
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF;  
u16 DeviceCode;	 

void LCD_write(u16 VAL)
{
	LCD_CS_CLR; 
	DATAOUT(VAL);
	LCD_WR_CLR;	
	LCD_WR_SET; 
	LCD_CS_SET;
}

u16 LCD_read(void)
{
	u16 data;
	LCD_CS_CLR;
	LCD_RD_CLR;
	Delay_Us(1);//ʱ1us	
	data = DATAIN;
	LCD_RD_SET;
	LCD_CS_SET;
	return data;
}

/*****************************************************************************
 * @name       :void LCD_WR_REG(u16 data)
 * @date       :2018-08-09 
 * @function   :Write an 16-bit command to the LCD screen
 * @parameters :data:Command value to be written
 * @retvalue   :None
******************************************************************************/
void LCD_WR_REG(u16 data)
{ 
   LCD_RS_CLR;     
	 LCD_write(data);
}

/*****************************************************************************
 * @name       :void LCD_WR_DATA(u16 data)
 * @date       :2018-08-09 
 * @function   :Write an 16-bit data to the LCD screen
 * @parameters :data:data value to be written
 * @retvalue   :None
******************************************************************************/
void LCD_WR_DATA(u16 data)
{
	 LCD_RS_SET;
	 LCD_write(data);
}

/*****************************************************************************
 * @name       :u16 LCD_RD_DATA(void)
 * @date       :2018-11-13 
 * @function   :Read an 16-bit value from the LCD screen
 * @parameters :None
 * @retvalue   :read value
******************************************************************************/
u16 LCD_RD_DATA(void)
{
	LCD_RS_SET; 
	return LCD_read();
}

/*****************************************************************************
 * @name       :void LCD_WriteReg(u16 LCD_Reg, u16 LCD_RegValue)
 * @date       :2018-08-09 
 * @function   :Write data into registers
 * @parameters :LCD_Reg:Register address
                LCD_RegValue:Data to be written
 * @retvalue   :None
******************************************************************************/
void LCD_WriteReg(u16 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}	   

/*****************************************************************************
 * @name       :u16 LCD_ReadReg(u16 LCD_Reg)
 * @date       :2018-11-13 
 * @function   :read value from specially registers
 * @parameters :LCD_Reg:Register address
 * @retvalue   :read value
******************************************************************************/
void LCD_ReadReg(u16 LCD_Reg,u16 *Rval,int n)
{
	LCD_WR_REG(LCD_Reg); 
	GPIOB->CFGLR=0X88888888; //PB0-7  
	GPIOB->CFGHR=0X88888888; //PB8-15 
	GPIOB->OUTDR=0XFFFF;     //ȫ
	while(n--)
	{		
		*(Rval++) = LCD_RD_DATA();
	}
	
	GPIOB->CFGLR=0X33333333; 		//PB0-7  
	GPIOB->CFGHR=0X33333333; 		//PB8-15 
	GPIOB->OUTDR=0XFFFF;    		//ȫ  
}

/*****************************************************************************
 * @name       :void LCD_WriteRAM_Prepare(void)
 * @date       :2018-08-09 
 * @function   :Write GRAM
 * @parameters :None
 * @retvalue   :None
******************************************************************************/	 
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(lcddev.wramcmd);
}	 

/*****************************************************************************
 * @name       :void LCD_ReadRAM_Prepare(void)
 * @date       :2018-11-13 
 * @function   :Read GRAM
 * @parameters :None
 * @retvalue   :None
******************************************************************************/	 
void LCD_ReadRAM_Prepare(void)
{
	LCD_WR_REG(lcddev.rramcmd);
}

/*****************************************************************************
 * @name       :void Lcd_WriteData_16Bit(u16 Data)
 * @date       :2018-08-09 
 * @function   :Write an 16-bit command to the LCD screen
 * @parameters :Data:Data to be written
 * @retvalue   :None
******************************************************************************/	 
void Lcd_WriteData_16Bit(u16 Data)
{	
   LCD_RS_SET; 
	 LCD_write(Data);
}

/*****************************************************************************
 * @name       :u16 Lcd_ReadData_16Bit(void)
 * @date       :2018-11-13 
 * @function   :Read an 16-bit value from the LCD screen
 * @parameters :None
 * @retvalue   :read value
******************************************************************************/	
u16 Lcd_ReadData_16Bit(void)
{
	u16 r;
	LCD_RS_SET;
	LCD_CS_CLR;
	
	//Dummy Read
	LCD_RD_CLR;
	Delay_Us(1);//ʱ1us	
	r = DATAIN;
	LCD_RD_SET;
	//read data
	LCD_RD_CLR;
	Delay_Us(1);//ʱ1us	
	r = DATAIN;
	LCD_RD_SET;

	LCD_CS_SET;
	return (r & 0x07E0) | (r >> 11) | (r << 11);
}

/*****************************************************************************
 * @name       :void LCD_DrawPoint(u16 x,u16 y)
 * @date       :2018-08-09 
 * @function   :Write a pixel data at a specified location
 * @parameters :x:the x coordinate of the pixel
                y:the y coordinate of the pixel
 * @retvalue   :None
******************************************************************************/	
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);//ùλ 
	Lcd_WriteData_16Bit(POINT_COLOR); 
}

/*****************************************************************************
 * @name       :u16 LCD_ReadPoint(u16 x,u16 y)
 * @date       :2018-11-13 
 * @function   :Read a pixel color value at a specified location
 * @parameters :x:the x coordinate of the pixel
                y:the y coordinate of the pixel
 * @retvalue   :the read color value
******************************************************************************/	
u16 LCD_ReadPoint(u16 x,u16 y)
{
	u16 color;
	if(x>=lcddev.width||y>=lcddev.height)
	{
		return 0;	//˷Χ,ֱӷ	
	}
	LCD_SetCursor(x,y);//ùλ 
	LCD_ReadRAM_Prepare();
	GPIOB->CFGLR=0X88888888; //PB0-7  
	GPIOB->CFGHR=0X88888888; //PB8-15 
	GPIOB->OUTDR=0XFFFF;     //ȫ
	
	color = Lcd_ReadData_16Bit();
	
	GPIOB->CFGLR=0X33333333; 		//PB0-7  
	GPIOB->CFGHR=0X33333333; 		//PB8-15 
	GPIOB->OUTDR=0XFFFF;    		//ȫ  
	return color;
}

/*****************************************************************************
 * @name       :void LCD_Clear(u16 Color)
 * @date       :2018-08-09 
 * @function   :Full screen filled LCD screen
 * @parameters :color:Filled color
 * @retvalue   :None
******************************************************************************/	
void LCD_Clear(u16 Color)
{
  unsigned int i;//,m;  
	LCD_SetWindows(0,0,lcddev.width-1,lcddev.height-1);   
	for(i=0;i<lcddev.height*lcddev.width;i++)
	{
			Lcd_WriteData_16Bit(Color);
	}
} 

/*****************************************************************************
 * @name       :void LCD_GPIOInit(void)
 * @date       :2018-08-09 
 * @function   :Initialization LCD screen GPIO
 * @parameters :None
 * @retvalue   :None
******************************************************************************/	
void LCD_GPIOInit(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	      
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_AFIO,ENABLE);
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5| GPIO_Pin_1| GPIO_Pin_4| GPIO_Pin_9 | GPIO_Pin_10|GPIO_Pin_15; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   //
	GPIO_Init(GPIOA, &GPIO_InitStructure);	
	GPIO_SetBits(GPIOA,GPIO_Pin_5| GPIO_Pin_1| GPIO_Pin_4| GPIO_Pin_9 | GPIO_Pin_10);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	//  
	GPIO_Init(GPIOB, &GPIO_InitStructure); //GPIOB
	GPIO_ResetBits(GPIOB,GPIO_Pin_All);	
}

/*****************************************************************************
 * @name       :void LCD_RESET(void)
 * @date       :2018-08-09 
 * @function   :Reset LCD screen
 * @parameters :None
 * @retvalue   :None
******************************************************************************/	
void LCD_RESET(void)
{
	LCD_RST_CLR;
	Delay_Ms(100);	
	LCD_RST_SET;
	Delay_Ms(50);
}

/*****************************************************************************
 * @name       :void LCD_Init(void)
 * @date       :2018-08-09 
 * @function   :Initialization LCD screen
 * @parameters :None
 * @retvalue   :None
******************************************************************************/	 	 
void LCD_Init(void)
{  
	LCD_GPIOInit();//LCD GPIOʼ	
 	LCD_RESET(); //LCD λ
//*************ST7775Rʼ**********//
	LCD_WR_REG(0x0001);
	LCD_WR_DATA(0x011C);
	LCD_WR_REG(0x0002);
	LCD_WR_DATA(0x0100);
	LCD_WR_REG(0x0003);
	LCD_WR_DATA(0x1030);
	LCD_WR_REG(0x0008);
	LCD_WR_DATA(0x0808);
	LCD_WR_REG(0x000C);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x000F);
	LCD_WR_DATA(0x0001);
	LCD_WR_REG(0x0020);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0021);
	LCD_WR_DATA(0x0000);
	//-----------------------------------End Display Control setting-----------------------------------------//
	//-------------------------------- Power Control Registers Initial --------------------------------------//
	LCD_WR_REG(0x0010);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0011);
	LCD_WR_DATA(0x1000);
	//---------------------------------End Power Control Registers Initial -------------------------------//
	Delay_Ms(100);
	//----------------------------------Display Windows 176 X 220----------------------------------------//
	LCD_WR_REG(0x0030);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0031);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0032);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0033);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0034);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0035);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0036);
	LCD_WR_DATA(0x00AF);
	LCD_WR_REG(0x0037);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0038);
	LCD_WR_DATA(0x00DB);
	LCD_WR_REG(0x0039);
	LCD_WR_DATA(0x0000);
	//----------------------------------End Display Windows 176 X 220----------------------------------//
	Delay_Ms(10);
	LCD_WR_REG(0x00ff);
	LCD_WR_DATA(0x0003);
	//-------------------------------------Gamma Cluster Setting-------------------------------------------//
	LCD_WR_REG(0x0050);
	LCD_WR_DATA(0x0203);
	LCD_WR_REG(0x0051);
	LCD_WR_DATA(0x0a09);
	LCD_WR_REG(0x0052);
	LCD_WR_DATA(0x0005);
	LCD_WR_REG(0x0053);
	LCD_WR_DATA(0x1021);
	LCD_WR_REG(0x0054);
	LCD_WR_DATA(0x0602);
	LCD_WR_REG(0x0055);
	LCD_WR_DATA(0x0003);
	LCD_WR_REG(0x0056);
	LCD_WR_DATA(0x0703);
	LCD_WR_REG(0x0057);
	LCD_WR_DATA(0x0507);
	LCD_WR_REG(0x0058);
	LCD_WR_DATA(0x1021);
	LCD_WR_REG(0x0059);
	LCD_WR_DATA(0x0703);
	//---------------------------------------End Gamma Setting---------------------------------------------//
	//--------------------------------------Vcom Setting---------------------------------------------//
	LCD_WR_REG(0x00B0);
	LCD_WR_DATA(0x2301);
	LCD_WR_REG(0x00B1); //Աȶ
	LCD_WR_DATA(0x0000);
	//---------------------------------------End Vcom Setting---------------------------------------------//
	LCD_WR_REG(0x00ff);
	LCD_WR_DATA(0x0000);
	LCD_WR_REG(0x0007);
	LCD_WR_DATA(0x1017);
	Delay_Ms(200); //Delay 200ms
  LCD_direction(USE_HORIZONTAL);//LCDʾ
	LCD_LED=1;//	 
	LCD_Clear(WHITE);//ȫɫ
}
 
/*****************************************************************************
 * @name       :void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
 * @date       :2018-08-09 
 * @function   :Setting LCD display window
 * @parameters :xStar:the bebinning x coordinate of the LCD display window
								yStar:the bebinning y coordinate of the LCD display window
								xEnd:the endning x coordinate of the LCD display window
								yEnd:the endning y coordinate of the LCD display window
 * @retvalue   :None
******************************************************************************/ 
void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{	
	u16 x,y,tmp;
	switch(lcddev.dir)
	{
		case 0:
			x = xStar;
			y = yStar;
			break;
		case 1:
			tmp = yStar;
			yStar = xStar;
			xStar = LCD_W-1-yEnd;
			yEnd = xEnd;
			xEnd = LCD_W-1-tmp;
			x = xEnd;
			y = yStar;
			break;
		case 2:
			tmp = xStar;
			xStar = LCD_W-1-xEnd;
			xEnd = LCD_W-1-tmp;
			tmp = yStar;
			yStar = LCD_H-1-yEnd;
			yEnd = LCD_H-1-tmp;
			x = xEnd;
			y = yEnd;
			break;
		case 3:
			tmp = xStar;
			xStar = yStar;
			yStar = LCD_H-1-xEnd;
			xEnd = yEnd;
			yEnd = LCD_H-1-tmp;
			x = xStar;
			y = yEnd;
			break;
		default:
			break;
	}
	LCD_WriteReg(0x0036, xEnd);
	LCD_WriteReg(0x0037, xStar);
	LCD_WriteReg(0x0038, yEnd);
	LCD_WriteReg(0x0039, yStar);
	LCD_WriteReg(lcddev.setxcmd, x);
	LCD_WriteReg(lcddev.setycmd, y);
	LCD_WriteRAM_Prepare();	//ʼдGRAM		
}   

/*****************************************************************************
 * @name       :void LCD_SetCursor(u16 Xpos, u16 Ypos)
 * @date       :2018-08-09 
 * @function   :Set coordinate value
 * @parameters :Xpos:the  x coordinate of the pixel
								Ypos:the  y coordinate of the pixel
 * @retvalue   :None
******************************************************************************/ 
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{	  	    			
	LCD_SetWindows(Xpos,Ypos,Xpos,Ypos);	
} 

/*****************************************************************************
 * @name       :void LCD_direction(u8 direction)
 * @date       :2018-08-09 
 * @function   :Setting the display direction of LCD screen
 * @parameters :direction:0-0 degree
                          1-90 degree
													2-180 degree
													3-270 degree
 * @retvalue   :None
******************************************************************************/ 
void LCD_direction(u8 direction)
{ 
			lcddev.dir = direction&3;
			lcddev.setxcmd=0x0020;
			lcddev.setycmd=0x0021;
			lcddev.wramcmd=0x0022;
			lcddev.rramcmd=0x0022;
	switch(lcddev.dir){		  
		case 0:						 	 		
			lcddev.width=LCD_W;
			lcddev.height=LCD_H;		
			LCD_WriteReg(0x0003,0x1030);
		break;
		case 1:
			lcddev.width=LCD_H;
			lcddev.height=LCD_W;
			LCD_WriteReg(0x0003,0x1028);
		break;
		case 2:						 	 		
			lcddev.width=LCD_W;
			lcddev.height=LCD_H;	
			LCD_WriteReg(0x0003,0x1000);
		break;
		case 3:
			lcddev.width=LCD_H;
			lcddev.height=LCD_W;
			LCD_WriteReg(0x0003,0x1018);
		break;	
		default:break;
	}	
}	 

/*****************************************************************************
 * @name       :u16 LCD_Read_ID(void)
 * @date       :2018-11-13 
 * @function   :Read ID
 * @parameters :None
 * @retvalue   :ID value
******************************************************************************/ 
u16 LCD_Read_ID(void)
{
	u16 val = 0;
	LCD_ReadReg(0x00,&val,1);
	return val;
}

